#include <Stepper.h>


const int trigPin = 3;
const int echoPin = 4;
int buzzPin = 12;
int redPin = 7;
int greenPin = 6;
int bluePin = 5;
float duration, distance,distancein,distance1;
int spr = 2048; //stepsPerRevolution
int motSpeed = 10;
int t=500;
int num;


Stepper myStepper(spr,8,10,9,11); //8=IN1, 11=IN4


void setup() {
  // put your setup code here, to run once:
   //setting the distance sensor pins. the trigger pin as an input and the echo pin as an output
   pinMode(trigPin, OUTPUT);
   pinMode(echoPin, INPUT);
   Serial.begin(9600);


   //buzzer - setting the buzzer pin as output
   pinMode(buzzPin,OUTPUT);

   //stepper 
   myStepper.setSpeed(motSpeed);

   //LED - setting the led pins as outputs 

   pinMode(redPin, OUTPUT);
   pinMode(greenPin, OUTPUT);
   pinMode(bluePin, OUTPUT);







}

void loop() {
  // put your main code here, to run repeatedly:
//activaitng the distance sensor
  digitalWrite(trigPin, LOW);
  delayMicroseconds(2);
  digitalWrite(trigPin, HIGH);
  delayMicroseconds(10);
  digitalWrite(trigPin, LOW);


  duration = pulseIn(echoPin, HIGH); //calculating the time for the pin to go from high to low
  distance = (duration*.0343)/2; // calculating the distance in cm
  distancein = distance/2.54; //distance in inches

  Serial.print("Distance:"); //printing the distance in the serial monitor 
  Serial.println(distance);
  delay(100);

//distance = distance1;
//buzzer

if(distance < 10){   //if the distance captured by the distance sensor is less than 10cm, the passive buzzer will be triggered 
  digitalWrite(buzzPin,HIGH);
  delay(1000);
  digitalWrite(buzzPin, LOW);
//  setStepper(distance);


}

if (distance<10){ //if the distance captured by the distance sensor is less than 10cm, the stepper motor will also be triggered 
  //stepper 
myStepper.step(500);


}

if(distance<10){  //calling the "setColor" to set the led color according to the distance 
  setColor(0,255,255);; // Red Color 
}
else if (distance >10 && distance < 80){
  setColor(0, 0, 255); // Purple Color
}
else {
  setColor(0, 255, 0); // Green Color
}


 
}


void setColor(int redValue, int greenValue, int blueValue) {  //function needed to set the rgb led color 
  analogWrite(redPin, redValue);
  analogWrite(greenPin, greenValue);
  analogWrite(bluePin, blueValue);
}
